diff --git a/src/main/java/net/minecraft/client/gui/GuiCredits.java b/src/main/java/net/minecraft/client/gui/CreditsScreen.java
similarity index 76%
rename from src/main/java/net/minecraft/client/gui/GuiCredits.java
rename to src/main/java/net/minecraft/client/gui/CreditsScreen.java
index 2b3d24f7c..5a711e93b 100644
--- a/src/main/java/net/minecraft/client/gui/GuiCredits.java
+++ b/src/main/java/net/minecraft/client/gui/CreditsScreen.java
@@ -1,15 +1,15 @@
 package net.minecraft.client.gui;
 
-import net.minecraft.client.gui.modelviewer.elements.GuiListenerButton;
+import com.mojang.logging.LogUtils;
+import net.minecraft.client.gui.modelviewer.elements.ListenerButtonElement;
 import net.minecraft.client.render.Scissor;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.TextFormatting;
-import net.minecraft.core.sound.SoundCategory;
-import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
 import org.lwjgl.opengl.GL11;
+import org.slf4j.Logger;
 
 import java.awt.*;
 import java.io.BufferedReader;
@@ -21,7 +21,8 @@ import java.util.List;
 
 import static org.lwjgl.opengl.GL11.*;
 
-public class GuiCredits extends GuiScreen {
+public class CreditsScreen extends Screen {
+    private static final Logger LOGGER = LogUtils.getLogger();
     private static final int TOP_SPACING = 24;
     private static final int BUTTON_SPACING = 4;
 
@@ -52,10 +53,10 @@ public class GuiCredits extends GuiScreen {
 
     private float hue = 0;
 
-    public GuiCredits(GuiScreen parent) {
+    public CreditsScreen(Screen parent) {
         super(parent);
 
-        try (InputStream stream = GuiMainMenu.class.getResourceAsStream("/credits.txt")) {
+        try (InputStream stream = MainMenuScreen.class.getResourceAsStream("/credits.txt")) {
 
             List<String> lines = new ArrayList<>();
             BufferedReader br = new BufferedReader(new InputStreamReader(stream, StandardCharsets.UTF_8));
@@ -70,7 +71,7 @@ public class GuiCredits extends GuiScreen {
             }
             this.lines = lines;
         } catch (Exception e) {
-            e.printStackTrace();
+            LOGGER.error("Exception when trying to load 'credits.txt'", e);
             this.lines = new ArrayList<>();
             this.lines.add("An error occurred while loading the credits.");
         }
@@ -81,9 +82,9 @@ public class GuiCredits extends GuiScreen {
         top = TOP_SPACING;
         bottom = height - (BUTTON_SPACING + 20 + BUTTON_SPACING);
         scrollRegionHeight = bottom - top;
-        add(new GuiListenerButton(0, width / 2 - 100, height - (BUTTON_SPACING + 20), 200, 20, I18n.getInstance().translateKey("gui.credits.button.done")).setActionListener(() -> {
-            onClosed();
-            mc.displayGuiScreen(null);
+        add(new ListenerButtonElement(0, width / 2 - 100, height - (BUTTON_SPACING + 20), 200, 20, I18n.getInstance().translateKey("gui.credits.button.done")).setActionListener(() -> {
+            removed();
+            mc.displayScreen(null);
         }));
 
         onScroll();
@@ -98,12 +99,12 @@ public class GuiCredits extends GuiScreen {
     }
 
     @Override
-    public void onClosed() {
+    public void removed() {
         mc.sndManager.stopMusic();
     }
 
     @Override
-    public void drawScreen(int mouseX, int mouseY, float partialTick) {
+    public void render(int xm, int ym, float partialTick) {
         // Handle scrolling
         if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL)) {
             scroll(Mouse.getDWheel() * -0.01f);
@@ -111,15 +112,15 @@ public class GuiCredits extends GuiScreen {
             scroll(Mouse.getDWheel() / -0.05f);
         }
 
-        drawDefaultBackground();
+        renderBackground();
         overlayBackground(0, width, 0, top);
         overlayBackground(0, width, bottom, height);
 
-        drawScrollBar(mouseX, mouseY);
+        drawScrollBar(xm, ym);
 
-        super.drawScreen(mouseX, mouseY, partialTick);
+        super.render(xm, ym, partialTick);
 
-        fontRenderer.drawCenteredString(I18n.getInstance().translateKey("gui.credits.label.title"), width / 2, 5, 0xFFFFFF);
+        font.drawCenteredString(I18n.getInstance().translateKey("gui.credits.label.title"), width / 2, 5, 0xFFFFFF);
 
         Scissor.enable(0, top, width, bottom - top);
         drawContent();
@@ -129,7 +130,7 @@ public class GuiCredits extends GuiScreen {
     }
 
     private void drawContent() {
-        mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/title/mclogo.png").bind();
+        mc.textureManager.loadTexture("/assets/minecraft/textures/gui/title/mclogo.png").bind();
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         drawTexturedModalRect(width / 2 - 274 / 2, 30 - (int)scrollAmount, 0, 0, 274, 50, 1d/274, 1d/50);
 
@@ -137,15 +138,15 @@ public class GuiCredits extends GuiScreen {
             String line = lines.get(i);
             if (line.startsWith("*")) {
                 line = TextFormatting.BOLD + line.substring(1);
-                int lineWidth = fontRenderer.getStringWidth(line) + line.length();
-                fontRenderer.drawString(line, width / 2 - lineWidth / 2, 100 + i * 12 - (int)scrollAmount, 0xFFFFFF);
+                int lineWidth = font.getStringWidth(line) + line.length();
+                font.drawString(line, width / 2 - lineWidth / 2, 100 + i * 12 - (int)scrollAmount, 0xFFFFFF);
             } else if (line.startsWith("!")) {
                 int rgb = Color.HSBtoRGB(hue / 360f, 1.0f, 1.0f);
                 line = TextFormatting.BOLD + line.substring(1);
-                int lineWidth = fontRenderer.getStringWidth(line) + line.length();
-                fontRenderer.drawString(line, width / 2 - lineWidth / 2, 100 + i * 12 - (int)scrollAmount, rgb);
+                int lineWidth = font.getStringWidth(line) + line.length();
+                font.drawString(line, width / 2 - lineWidth / 2, 100 + i * 12 - (int)scrollAmount, rgb);
             } else {
-                fontRenderer.drawString(line, width / 2 - fontRenderer.getStringWidth(line) / 2, 100 + i * 12 - (int) scrollAmount, 0x7F7F7F);
+                font.drawString(line, width / 2 - font.getStringWidth(line) / 2, 100 + i * 12 - (int) scrollAmount, 0x7F7F7F);
             }
         }
     }
@@ -196,19 +197,19 @@ public class GuiCredits extends GuiScreen {
     }
 
     @Override
-    public void mouseClicked(int mouseX, int mouseY, int mouseButton) {
-        super.mouseClicked(mouseX, mouseY, mouseButton);
+    public void mouseClicked(int mx, int my, int buttonNum) {
+        super.mouseClicked(mx, my, buttonNum);
 
-        clickX = mouseX;
-        clickY = mouseY;
+        clickX = mx;
+        clickY = my;
     }
 
     @Override
-    public void drawDefaultBackground() {
-        super.drawDefaultBackground();
+    public void renderBackground() {
+        super.renderBackground();
 
         Tessellator tessellator = Tessellator.instance;
-        mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
+        mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         float scale = 32F;
         tessellator.startDrawingQuads();
@@ -225,7 +226,7 @@ public class GuiCredits extends GuiScreen {
     private void overlayBackground(int minX, int maxX, int minY, int maxY) {
         if (mc.theWorld == null) {
             Tessellator tessellator = Tessellator.instance;
-            mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
+            mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             float scale = 32F;
             tessellator.startDrawingQuads();
@@ -259,10 +260,10 @@ public class GuiCredits extends GuiScreen {
     }
 
     @Override
-    public void mouseMovedOrButtonReleased(int mouseX, int mouseY, int mouseButton) {
-        super.mouseMovedOrButtonReleased(mouseX, mouseY, mouseButton);
+    public void mouseReleased(int mx, int my, int buttonNum) {
+        super.mouseReleased(mx, my, buttonNum);
 
-        if (mouseButton >= 0) {
+        if (buttonNum >= 0) {
             clickX = null;
             clickY = null;
         }
diff --git a/src/main/java/net/minecraft/client/gui/GuiDownloadTerrain.java b/src/main/java/net/minecraft/client/gui/DownloadTerrainScreen.java
similarity index 63%
rename from src/main/java/net/minecraft/client/gui/GuiDownloadTerrain.java
rename to src/main/java/net/minecraft/client/gui/DownloadTerrainScreen.java
index 4ee1d3c2d..02c672600 100644
--- a/src/main/java/net/minecraft/client/gui/GuiDownloadTerrain.java
+++ b/src/main/java/net/minecraft/client/gui/DownloadTerrainScreen.java
@@ -8,24 +8,24 @@ import net.minecraft.client.net.handler.ClientPacketHandler;
 import net.minecraft.core.net.packet.KeepAlivePacket;
 import net.minecraft.core.lang.I18n;
 
-public class GuiDownloadTerrain extends GuiScreen
+public class DownloadTerrainScreen extends Screen
 {
 
-    public GuiDownloadTerrain(ClientPacketHandler netclienthandler)
+    public DownloadTerrainScreen(ClientPacketHandler netclienthandler)
     {
         updateCounter = 0;
         netHandler = netclienthandler;
     }
 
     @Override
-	public void keyTyped(char c, int i, int mouseX, int mouseY)
+	public void keyPressed(char eventCharacter, int eventKey, int mx, int my)
     {
     }
 
     @Override
 	public void init()
     {
-        controlList.clear();
+        buttons.clear();
     }
 
     @Override
@@ -43,18 +43,18 @@ public class GuiDownloadTerrain extends GuiScreen
     }
 
     @Override
-	protected void buttonPressed(GuiButton button)
+	protected void buttonClicked(ButtonElement button)
     {
     }
 
     @Override
 
-	public void drawScreen(int mouseX, int mouseY, float partialTick)
+	public void render(int xm, int ym, float partialTick)
     {
-        drawBackground();
+        renderTexturedBackground();
         I18n i18n = I18n.getInstance();
-        drawStringCentered(fontRenderer, i18n.translateKey("gui.downloading_terrain.label.title"), width / 2, height / 2 - 50, 0xffffff);
-        super.drawScreen(mouseX, mouseY, partialTick);
+        drawStringCentered(font, i18n.translateKey("gui.downloading_terrain.label.title"), width / 2, height / 2 - 50, 0xffffff);
+        super.render(xm, ym, partialTick);
     }
 
     private ClientPacketHandler netHandler;
diff --git a/src/main/java/net/minecraft/client/gui/GuiSurface.java b/src/main/java/net/minecraft/client/gui/DrawableSurfaceElement.java
similarity index 89%
rename from src/main/java/net/minecraft/client/gui/GuiSurface.java
rename to src/main/java/net/minecraft/client/gui/DrawableSurfaceElement.java
index a17b0e219..ae3754886 100644
--- a/src/main/java/net/minecraft/client/gui/GuiSurface.java
+++ b/src/main/java/net/minecraft/client/gui/DrawableSurfaceElement.java
@@ -1,92 +1,92 @@
-package net.minecraft.client.gui;
-
-import net.minecraft.client.gui.drawing.IDrawableSurface;
-
-public class GuiSurface
-    extends Gui
-    implements IDrawableSurface<Byte>
-{
-    private final int canvasWidth;
-    private final int canvasHeight;
-    private final int canvasScale;
-    private final byte[] surfaceData;
-    public int[] colors = new int[0];
-
-    public GuiSurface(int width, int height, int scale)
-    {
-        this(width, height, scale, new byte[width * height]);
-    }
-
-    public GuiSurface(int width, int height, int scale, byte[] surfaceData)
-    {
-        this.canvasWidth = width;
-        this.canvasHeight = height;
-        this.canvasScale = scale;
-        this.surfaceData = surfaceData;
-    }
-
-    public void render(int x, int y)
-    {
-        for (int dx = 0; dx < canvasWidth; dx++)
-        {
-            for (int dy = 0; dy < canvasHeight; dy++)
-            {
-                drawRectNoBlend(x + dx * canvasScale, y + dy * canvasScale, x + dx * canvasScale + canvasScale, y + dy * canvasScale + canvasScale, getColor(getPixelValue(dx, dy)));
-            }
-        }
-    }
-
-    private int getColor(byte val)
-    {
-        if (val < 0 || val >= colors.length)
-        {
-            return 0x00000000;
-        }
-        else
-        {
-            return colors[val];
-        }
-    }
-
-    public void clear()
-    {
-        for (int dx = 0; dx < canvasWidth; dx++)
-        {
-            for (int dy = 0; dy < canvasHeight; dy++)
-            {
-                setPixelValue(dx, dy, (byte)0);
-            }
-        }
-    }
-
-    @Override
-    public int getWidth()
-    {
-        return canvasWidth;
-    }
-
-    @Override
-    public int getHeight()
-    {
-        return canvasHeight;
-    }
-
-    @Override
-    public Byte getPixelValue(int x, int y)
-    {
-        if (x < 0 || x >= canvasWidth) return 0;
-        if (y < 0 || y >= canvasHeight) return 0;
-
-        return surfaceData[x + canvasWidth * y];
-    }
-
-    @Override
-    public boolean setPixelValue(int x, int y, Byte value)
-    {
-        if (x < 0 || x >= canvasWidth) return false;
-        if (y < 0 || y >= canvasHeight) return false;
-
-        surfaceData[x + canvasWidth * y] = value;
-        return true;
-    }
-}
+package net.minecraft.client.gui;
+
+import net.minecraft.client.gui.drawing.IDrawableSurface;
+
+public class DrawableSurfaceElement
+    extends Gui
+    implements IDrawableSurface<Byte>
+{
+    private final int canvasWidth;
+    private final int canvasHeight;
+    private final int canvasScale;
+    private final byte[] surfaceData;
+    public int[] colors = new int[0];
+
+    public DrawableSurfaceElement(int width, int height, int scale)
+    {
+        this(width, height, scale, new byte[width * height]);
+    }
+
+    public DrawableSurfaceElement(int width, int height, int scale, byte[] surfaceData)
+    {
+        this.canvasWidth = width;
+        this.canvasHeight = height;
+        this.canvasScale = scale;
+        this.surfaceData = surfaceData;
+    }
+
+    public void render(int x, int y)
+    {
+        for (int dx = 0; dx < canvasWidth; dx++)
+        {
+            for (int dy = 0; dy < canvasHeight; dy++)
+            {
+                drawRectNoBlend(x + dx * canvasScale, y + dy * canvasScale, x + dx * canvasScale + canvasScale, y + dy * canvasScale + canvasScale, getColor(getPixelValue(dx, dy)));
+            }
+        }
+    }
+
+    private int getColor(byte val)
+    {
+        if (val < 0 || val >= colors.length)
+        {
+            return 0x00000000;
+        }
+        else
+        {
+            return colors[val];
+        }
+    }
+
+    public void clear()
+    {
+        for (int dx = 0; dx < canvasWidth; dx++)
+        {
+            for (int dy = 0; dy < canvasHeight; dy++)
+            {
+                setPixelValue(dx, dy, (byte)0);
+            }
+        }
+    }
+
+    @Override
+    public int getWidth()
+    {
+        return canvasWidth;
+    }
+
+    @Override
+    public int getHeight()
+    {
+        return canvasHeight;
+    }
+
+    @Override
+    public Byte getPixelValue(int x, int y)
+    {
+        if (x < 0 || x >= canvasWidth) return 0;
+        if (y < 0 || y >= canvasHeight) return 0;
+
+        return surfaceData[x + canvasWidth * y];
+    }
+
+    @Override
+    public boolean setPixelValue(int x, int y, Byte value)
+    {
+        if (x < 0 || x >= canvasWidth) return false;
+        if (y < 0 || y >= canvasHeight) return false;
+
+        surfaceData[x + canvasWidth * y] = value;
+        return true;
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/GuiException.java b/src/main/java/net/minecraft/client/gui/ExceptionPopupElement.java
similarity index 91%
rename from src/main/java/net/minecraft/client/gui/GuiException.java
rename to src/main/java/net/minecraft/client/gui/ExceptionPopupElement.java
index 71de3b752..81b614e77 100644
--- a/src/main/java/net/minecraft/client/gui/GuiException.java
+++ b/src/main/java/net/minecraft/client/gui/ExceptionPopupElement.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.gui;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.popup.GuiPopup;
+import net.minecraft.client.gui.popup.PopupScreen;
 import net.minecraft.client.gui.popup.PopupBuilder;
 import net.minecraft.client.gui.popup.PopupCloseListener;
 import net.minecraft.core.net.command.TextFormatting;
@@ -14,9 +14,9 @@ import java.text.SimpleDateFormat;
 import java.util.Date;
 import java.util.Map;
 
-public class GuiException {
+public class ExceptionPopupElement {
 
-    public static GuiPopup create(GuiScreen parent, Throwable e, Minecraft mc){
+    public static PopupScreen create(Screen parent, Throwable e, Minecraft mc){
         int scale = Math.max(mc.resolution.scale,1);
         StringBuilder s = new StringBuilder("Minecraft ran into an unexpected problem!\n\n");
         s.append("To prevent more problems, the current game has quit, but you can try to keep playing.\n\n");
@@ -51,15 +51,15 @@ public class GuiException {
         s.append(TextFormatting.WHITE);
 
 
-        GuiPopup popup = new PopupBuilder(parent,860/scale).withLabel("gui.exception.label.exception_occurred")
-                .withMessageBox("gui.exception.list",400/scale,s.toString(),(860/scale) / mc.fontRenderer.getCharWidth('m'))
+        PopupScreen popup = new PopupBuilder(parent,860/scale).withLabel("gui.exception.label.exception_occurred")
+                .withMessageBox("gui.exception.list",400/scale,s.toString(),(860/scale) / mc.font.getCharWidth('m'))
                 .withButtonGroup("gui.exception.choice",new String[]{"gui.exception.button.back","gui.exception.button.copy_error"},new int[]{0,1})
                 .withOnCloseListener(new PopupListener(mc,s.toString().replaceAll("§[0-9a-f|klmnor]","")))
                 .build();
         return popup;
     }
 
-    public static GuiPopup createFatal(Throwable e, Minecraft mc){
+    public static PopupScreen createFatal(Throwable e, Minecraft mc){
         int scale = Math.max(mc.resolution.scale,1);
         StringBuilder s = new StringBuilder("Minecraft ran into an unexpected problem that it cannot recover from!\n\n");
         s.append("The current game has quit, please restart the game.\n\n");
@@ -93,10 +93,10 @@ public class GuiException {
         }
         s.append(TextFormatting.WHITE);
 
-        GuiBlank gui = new GuiBlank();
-        mc.displayGuiScreen(gui);
-        GuiPopup popup = new PopupBuilder(gui,860/scale).withLabel("gui.exception.label.fatal_error")
-                .withMessageBox("gui.exception.list",400/scale,s.toString(),(860/scale) / mc.fontRenderer.getCharWidth('m'))
+        BlankScreen screen = new BlankScreen();
+        mc.displayScreen(screen);
+        PopupScreen popup = new PopupBuilder(screen,860/scale).withLabel("gui.exception.label.fatal_error")
+                .withMessageBox("gui.exception.list",400/scale,s.toString(),(860/scale) / mc.font.getCharWidth('m'))
                 .withButtonGroup("gui.exception.choice",new String[]{"gui.exception.button.copy_error","gui.exception.button.copy_error_and_quit"},new int[]{0,2},new boolean[]{false,true})
                 .withBackgroundColor(0xff402020, 0xff501010)
                 .withOnCloseListener(new PopupListener(mc,s.toString().replaceAll("§[0-9a-f|klmnor]","")))
@@ -104,7 +104,7 @@ public class GuiException {
         return popup;
     }
 
-    public static GuiPopup createStartupError(Throwable e, Minecraft mc){
+    public static PopupScreen createStartupError(Throwable e, Minecraft mc){
         int scale = Math.max(mc.resolution.scale,1);
         StringBuilder s = new StringBuilder("An error has prevented Minecraft from starting up correctly!\n\n");
         s.append("The game cannot continue, please restart the game.\n\n");
@@ -138,10 +138,10 @@ public class GuiException {
         }
         s.append(TextFormatting.WHITE);
 
-        GuiBlank gui = new GuiBlank();
-        mc.displayGuiScreen(gui);
-        GuiPopup popup = new PopupBuilder(gui,860/scale).withLabel("gui.exception.label.startup_error")
-                .withMessageBox("gui.exception.list",400/scale,s.toString(),(860/scale) / mc.fontRenderer.getCharWidth('m'))
+        BlankScreen screen = new BlankScreen();
+        mc.displayScreen(screen);
+        PopupScreen popup = new PopupBuilder(screen,860/scale).withLabel("gui.exception.label.startup_error")
+                .withMessageBox("gui.exception.list",400/scale,s.toString(),(860/scale) / mc.font.getCharWidth('m'))
                 .withButtonGroup("gui.exception.choice",new String[]{"gui.exception.button.copy_error","gui.exception.button.copy_error_and_quit"},new int[]{0,2},new boolean[]{false,true})
                 .withBackgroundColor(0xff402020, 0xff501010)
                 .withOnCloseListener(new PopupListener(mc,s.toString().replaceAll("§[0-9a-f|klmnor]","")))
diff --git a/src/main/java/net/minecraft/client/gui/GuiGameOver.java b/src/main/java/net/minecraft/client/gui/GameOverScreen.java
similarity index 66%
rename from src/main/java/net/minecraft/client/gui/GuiGameOver.java
rename to src/main/java/net/minecraft/client/gui/GameOverScreen.java
index ee948cfb7..0faff9750 100644
--- a/src/main/java/net/minecraft/client/gui/GuiGameOver.java
+++ b/src/main/java/net/minecraft/client/gui/GameOverScreen.java
@@ -11,11 +11,11 @@ import net.minecraft.core.net.command.TextFormatting;
 // Referenced classes of package net.minecraft.src:
 //            GuiScreen, GuiButton, LocalPlayer, GuiMainMenu
 
-public class GuiGameOver extends GuiScreen
+public class GameOverScreen extends Screen
 {
     protected int tickCount = 0;
 
-    public GuiGameOver()
+    public GameOverScreen()
     {
     }
     @Override
@@ -31,51 +31,51 @@ public class GuiGameOver extends GuiScreen
 	public void init()
     {
         I18n i18n = I18n.getInstance();
-        controlList.clear();
+        buttons.clear();
         String respawnKey = (mc.thePlayer.getGamemode() == Gamemode.hardcore || mc.thePlayer.getGamemode() == Gamemode.spectator) ? "gui.game_over.button.respawn.spectator" : "gui.game_over.button.respawn";
-        controlList.add(new GuiButton(1, width / 2 - 100, height / 4 + 72, i18n.translateKey(respawnKey)));
-        controlList.add(new GuiButton(2, width / 2 - 100, height / 4 + 96, i18n.translateKey("gui.game_over.button.title_screen")));
+        buttons.add(new ButtonElement(1, width / 2 - 100, height / 4 + 72, i18n.translateKey(respawnKey)));
+        buttons.add(new ButtonElement(2, width / 2 - 100, height / 4 + 96, i18n.translateKey("gui.game_over.button.title_screen")));
         if(mc.session == null)
         {
-            controlList.get(1).enabled = false;
+            buttons.get(1).enabled = false;
         }
     }
 
     @Override
-	public void keyTyped(char c, int i, int mouseX, int mouseY)
+	public void keyPressed(char eventCharacter, int eventKey, int mx, int my)
     {
     }
 
     @Override
-	protected void buttonPressed(GuiButton button)
+	protected void buttonClicked(ButtonElement button)
     {
         if(button.id == 1)
         {
             mc.thePlayer.respawnPlayer();
-            mc.displayGuiScreen(null);
+            mc.displayScreen(null);
         }
         if(button.id == 2)
         {
             mc.changeWorld(null);
-            mc.displayGuiScreen(new GuiMainMenu());
+            mc.displayScreen(new MainMenuScreen());
         }
     }
 
     @Override
-	public void drawScreen(int mouseX, int mouseY, float partialTick)
+	public void render(int xm, int ym, float partialTick)
     {
         I18n i18n = I18n.getInstance();
         drawGradientRect(0, 0, width, height, 0x60500000, 0xa0803030);
         GL11.glPushMatrix();
         GL11.glScalef(2.0F, 2.0F, 2.0F);
-        drawStringCentered(fontRenderer, i18n.translateKey("gui.game_over.label.title"), width / 2 / 2, 30, 0xffffff);
+        drawStringCentered(font, i18n.translateKey("gui.game_over.label.title"), width / 2 / 2, 30, 0xffffff);
         GL11.glPopMatrix();
-        drawStringCentered(fontRenderer, i18n.translateKeyAndFormat("gui.game_over.label.score", TextFormatting.YELLOW.toString() + mc.thePlayer.getScore()), width / 2, 100, 0xffffff);
-        super.drawScreen(mouseX, mouseY, partialTick);
+        drawStringCentered(font, i18n.translateKeyAndFormat("gui.game_over.label.score", TextFormatting.YELLOW.toString() + mc.thePlayer.getScore()), width / 2, 100, 0xffffff);
+        super.render(xm, ym, partialTick);
     }
 
     @Override
-	public boolean pausesGame()
+	public boolean isPauseScreen()
     {
         return false;
     }
diff --git a/src/main/java/net/minecraft/client/gui/Gui.java b/src/main/java/net/minecraft/client/gui/Gui.java
index f7256c09a..8fb5e1005 100644
--- a/src/main/java/net/minecraft/client/gui/Gui.java
+++ b/src/main/java/net/minecraft/client/gui/Gui.java
@@ -3,8 +3,8 @@ package net.minecraft.client.gui;
 import static org.lwjgl.opengl.GL11.*;
 
 import net.minecraft.client.lang.text.Text;
-import net.minecraft.client.render.FontRenderer;
-import net.minecraft.client.render.RenderEngine;
+import net.minecraft.client.render.Font;
+import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.texture.Texture;
 import net.minecraft.client.render.texture.meta.gui.GuiTextureProperties;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
@@ -69,7 +69,7 @@ public class Gui
         drawRectDouble(minX, minY + 1, minX + 1, maxY, argb);
     }
 
-    protected void drawRect(int minX, int minY, int maxX, int maxY, int argb)
+    public void drawRect(int minX, int minY, int maxX, int maxY, int argb)
     {
         if(minX < maxX)
         {
@@ -218,42 +218,42 @@ public class Gui
         GL11.glEnable(GL_TEXTURE_2D);
     }
 
-    public void drawTextCentered(FontRenderer fr, Text text, int x, int y, int argb)
+    public void drawTextCentered(Font fr, Text text, int x, int y, int argb)
     {
         fr.drawTextWithShadow(text, x - fr.getTextWidth(text) / 2, y, argb);
     }
 
-    public void drawTextCenteredNoShadow(FontRenderer fr, Text text, int x, int y, int argb)
+    public void drawTextCenteredNoShadow(Font fr, Text text, int x, int y, int argb)
     {
         fr.drawText(text, x - fr.getTextWidth(text) / 2, y, argb);
     }
 
-    public void drawText(FontRenderer fr, Text text, int x, int y, int argb)
+    public void drawText(Font fr, Text text, int x, int y, int argb)
     {
         fr.drawTextWithShadow(text, x, y, argb);
     }
 
-    public void drawTextNoShadow(FontRenderer fr, Text text, int x, int y, int argb)
+    public void drawTextNoShadow(Font fr, Text text, int x, int y, int argb)
     {
         fr.drawText(text, x, y, argb);
     }
 
-    public void drawStringCentered(FontRenderer fr, String string, int x, int y, int argb)
+    public void drawStringCentered(Font fr, String string, int x, int y, int argb)
     {
         fr.drawStringWithShadow(string, x - fr.getStringWidth(string) / 2, y, argb);
     }
     
-    public void drawStringCenteredNoShadow(FontRenderer fr, String string, int x, int y, int argb)
+    public void drawStringCenteredNoShadow(Font fr, String string, int x, int y, int argb)
     {
         fr.drawString(string, x - fr.getStringWidth(string) / 2, y, argb);
     }
 
-    public void drawString(FontRenderer fr, String string, int x, int y, int argb)
+    public void drawString(Font fr, String string, int x, int y, int argb)
     {
         fr.drawStringWithShadow(string, x, y, argb);
     }
     
-    public void drawStringNoShadow(FontRenderer fr, String string, int x, int y, int argb)
+    public void drawStringNoShadow(Font fr, String string, int x, int y, int argb)
     {
     	fr.drawString(string, x, y, argb);
     }
@@ -379,7 +379,7 @@ public class Gui
         drawGuiIcon(x, y, 18, 18, TextureRegistry.getTexture("minecraft:gui/slot"));
     }
 
-    public void drawGuiTexture(RenderEngine re, int x, int y, int width, int height, String texture) {
+    public void drawGuiTexture(TextureManager re, int x, int y, int width, int height, String texture) {
         Texture tex = re.loadTexture(texture);
         tex.bind();
 
diff --git a/src/main/java/net/minecraft/client/gui/GuiHeldItemTooltip.java b/src/main/java/net/minecraft/client/gui/HeldItemTooltipElement.java
similarity index 93%
rename from src/main/java/net/minecraft/client/gui/GuiHeldItemTooltip.java
rename to src/main/java/net/minecraft/client/gui/HeldItemTooltipElement.java
index 4d4b2fbc7..32e54b30f 100644
--- a/src/main/java/net/minecraft/client/gui/GuiHeldItemTooltip.java
+++ b/src/main/java/net/minecraft/client/gui/HeldItemTooltipElement.java
@@ -8,7 +8,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.util.helper.Time;
 
-public class GuiHeldItemTooltip extends Gui {
+public class HeldItemTooltipElement extends Gui {
 
 	private Minecraft mc;
 	
@@ -24,7 +24,7 @@ public class GuiHeldItemTooltip extends Gui {
 	private final double displayTime = 2.5;
 	private final double fadeTime = 0.5;
 	
-	public GuiHeldItemTooltip(Minecraft mc) {
+	public HeldItemTooltipElement(Minecraft mc) {
 		this.mc = mc;
 	}
 	
@@ -126,7 +126,7 @@ public class GuiHeldItemTooltip extends Gui {
 			glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
 		}
 
-		mc.fontRenderer.drawStringWithShadow(string, x - (mc.fontRenderer.getStringWidth(string)) / 2, y, rgb);
+		mc.font.drawStringWithShadow(string, x - (mc.font.getStringWidth(string)) / 2, y, rgb);
 
 		glDisable(GL_BLEND);
 		glEnable(GL_ALPHA_TEST);
